using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using CanAerospaceCore;
using FTD2XX_NET;
using System.Threading;

namespace WindowsFormsApplication2.RPG7
{
    public partial class RPG7Form : Form
    {
        public RPG7Form()
        {
            InitializeComponent();
        }

        private void rpg7_main_Load(object sender, EventArgs e)
        {
            StartPosition = FormStartPosition.Manual;
            Location = Properties.Settings.Default.RPG7_FormLocation;
        }

        private void RPG7Form_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.RPG7_FormLocation = Location;
            Properties.Settings.Default.Save();
        }
        /*
        

            RPG7_accelerhor.Value = 45;
            RPG7_accelerver.Value = 45;

            
            RPG7_frontsight.ForeColor = Color.FromKnownColor(KnownColor.Silver);
            RPG7_frontsight.ForeColor = Color.FromKnownColor(KnownColor.Lime);
            RPG7_boltb.ForeColor = Color.FromKnownColor(KnownColor.Silver);
            RPG7_boltb.ForeColor = Color.FromKnownColor(KnownColor.Lime);
            RPG7_boltf.ForeColor = Color.FromKnownColor(KnownColor.Silver);
            RPG7_boltf.ForeColor = Color.FromKnownColor(KnownColor.Lime);
        }*/

        private void RPG7_refresh_Click(object sender, EventArgs e)
        {
            Form1 mainform = Application.OpenForms.OfType<Form1>().First();
            mainform.ActiveForm2 = null;
            this.Close();
        }

        private void RPG7_button_click(object sender, EventArgs e)
        {
            if (Application.OpenForms.OfType<Form1>().Any())
            {
                Form1 mainform = Application.OpenForms.OfType<Form1>().First();
                if (mainform.ActiveForm2 != null)
                {
                    Button button = sender as Button;
                    uint weaponChannel = 100;
                    byte weaponNodeId = 135;
                    CanData dataToWrite = new CanData();
                    //Thread.Sleep(1000);
                    byte register = 10;
                    switch (button.Name)
                    {
                        case ("RPG7_shot"):
                            dataToWrite.SetAsUchar((byte)(16));
                            break;
                        default:
                            return;
                        //break;
                    }
                    RegisterKey regKey = new RegisterKey(weaponNodeId, register);
                    mainform.canConnection.SendRegisterWriteRequest(weaponChannel, regKey, dataToWrite);
                }

            }

        }

        public void RPG7_numericUpDown_ValueChanged(object sender, EventArgs e)
        {
            NumericUpDown editbox = sender as NumericUpDown;
            uint weaponChannel = 100;
            byte weaponNodeId = 135;
            CanData dataToWrite = new CanData();
            //Thread.Sleep(1000);

            byte register = 0;
            switch (editbox.Name)
            {
                case ("RPG7_treshlow"):
                    register = 29;
                    dataToWrite.SetAsUchar((byte)(editbox.Value));
                    break;
                case ("RPG7_treshhigh"):
                    register = 30;
                    dataToWrite.SetAsUchar((byte)(editbox.Value));
                    break;
                case ("RPG7_voltoffset"):
                    register = 33;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("RPG7_dagain"):
                    register = 34;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                default:
                    return;
                //break;
            }
            if (register == 0) return;
            if (Application.OpenForms.OfType<Form1>().Any())
            {
                Form1 mainform = Application.OpenForms.OfType<Form1>().First();
                if (mainform.ActiveForm2 != null)
                {
                    RegisterKey regKey = new RegisterKey(weaponNodeId, register);
                    if (mainform.canConnection.SendRegisterWriteRequest(weaponChannel, regKey, dataToWrite)) MessageBox.Show("Value changed");
                }

            }

        }


    }
}
